OpenTTD: OrdersWindow Struct Reference

OpenTTD

- Main Page
- Related Pages
- Modules
- Namespaces
- Data Structures
- Files

- Data Structures
- Class Hierarchy
- Data Fields

Public Member Functions | Static Public Attributes | Private Types | Private Member Functions | Private Attributes
OrdersWindow Struct Reference

Order window code for all vehicles. More...

Inheritance diagram for OrdersWindow:

## Public Member Functions
| OrdersWindow (WindowDesc *desc, const Vehicle *v)
virtual void | UpdateWidgetSize (int widget, Dimension *size, const Dimension &padding, Dimension *fill, Dimension *resize)
| Update size and resize step of a widget in the window.
virtual void | OnInvalidateData (int data=0, bool gui_scope=true)
| Some data on this window has become invalid.
void | UpdateButtonState ()
virtual void | OnPaint ()
| The window must be repainted.
virtual void | DrawWidget (const Rect &r, int widget) const
| Draw the contents of a nested widget.
virtual void | SetStringParameters (int widget) const
| Initialize string parameters for a widget.
virtual void | OnClick (Point pt, int widget, int click_count)
| A click with the left mouse button has been made on the window.
virtual void | OnQueryTextFinished (char *str)
| The query window opened from this window has closed.
virtual void | OnDropdownSelect (int widget, int index)
| A dropdown option associated to this window has been selected.
virtual void | OnDragDrop (Point pt, int widget)
| A dragged 'object' has been released.
virtual EventState | OnHotkey (int hotkey)
| A hotkey has been pressed.
virtual void | OnPlaceObject (Point pt, TileIndex tile)
| The user clicked some place on the map when a tile highlight mode has been set.
virtual bool | OnVehicleSelect (const Vehicle *v)
virtual void | OnPlaceObjectAbort ()
| The user cancelled a tile highlight mode that has been set.
virtual void | OnMouseDrag (Point pt, int widget)
| An 'object' is being dragged at the provided position, highlight the target if possible.
virtual void | OnResize ()
| Called after the window got resized.
Public Member Functions inherited from Window
| Window (WindowDesc *desc)
| Empty constructor, initialization has been moved to InitNested() called from the constructor of the derived class.
virtual | ~Window ()
| Remove window and all its child windows from the window stack.
void * | operator new[] (size_t size)
| Helper allocation function to disallow something.
void | operator delete (void *ptr)
| Helper allocation function to disallow something.
template<class NWID >
const NWID * | GetWidget (uint widnum) const
| Specialized case of Window::GetWidget for the nested widget base class.
template<class NWID >
NWID * | GetWidget (uint widnum)
| Get the nested widget with number widnum from the nested widget tree.
const Scrollbar * | GetScrollbar (uint widnum) const
| Return the Scrollbar to a widget index.
Scrollbar * | GetScrollbar (uint widnum)
| Return the Scrollbar to a widget index.
const QueryString * | GetQueryString (uint widnum) const
| Return the querystring associated to a editbox.
QueryString * | GetQueryString (uint widnum)
| Return the querystring associated to a editbox.
virtual const char * | GetFocusedText () const
| Get the current input text if an edit box has the focus.
virtual const char * | GetCaret () const
| Get the string at the caret if an edit box has the focus.
virtual const char * | GetMarkedText (size_t *length) const
| Get the range of the currently marked input text.
virtual Point | GetCaretPosition () const
| Get the current caret position if an edit box has the focus.
virtual Rect | GetTextBoundingRect (const char *from, const char *to) const
| Get the bounding rectangle for a text range if an edit box has the focus.
virtual const char * | GetTextCharacterAtPosition (const Point &pt) const
| Get the character that is rendered at a position by the focused edit box.
void | InitNested (WindowNumber number=0)
| Perform complete initialization of the Window with nested widgets, to allow use.
void | CreateNestedTree (bool fill_nested=true)
| Perform the first part of the initialization of a nested widget tree.
void | FinishInitNested (WindowNumber window_number=0)
| Perform the second part of the initialization of a nested widget tree.
void | SetTimeout ()
| Set the timeout flag of the window and initiate the timer.
void | SetWhiteBorder ()
| Set the timeout flag of the window and initiate the timer.
void | DisableAllWidgetHighlight ()
| Disable the highlighted status of all widgets.
void | SetWidgetHighlight (byte widget_index, TextColour highlighted_colour)
| Sets the highlighted status of a widget.
bool | IsWidgetHighlighted (byte widget_index) const
| Gets the highlighted status of a widget.
void | SetWidgetDisabledState (byte widget_index, bool disab_stat)
| Sets the enabled/disabled status of a widget.
void | DisableWidget (byte widget_index)
| Sets a widget to disabled.
void | EnableWidget (byte widget_index)
| Sets a widget to Enabled.
bool | IsWidgetDisabled (byte widget_index) const
| Gets the enabled/disabled status of a widget.
bool | IsWidgetFocused (byte widget_index) const
| Check if given widget is focused within this window.
bool | IsWidgetGloballyFocused (byte widget_index) const
| Check if given widget has user input focus.
void | SetWidgetLoweredState (byte widget_index, bool lowered_stat)
| Sets the lowered/raised status of a widget.
void | ToggleWidgetLoweredState (byte widget_index)
| Invert the lowered/raised status of a widget.
void | LowerWidget (byte widget_index)
| Marks a widget as lowered.
void | RaiseWidget (byte widget_index)
| Marks a widget as raised.
bool | IsWidgetLowered (byte widget_index) const
| Gets the lowered state of a widget.
void | UnfocusFocusedWidget ()
| Makes no widget on this window have focus.
bool | SetFocusedWidget (int widget_index)
| Set focus within this window to the given widget.
EventState | HandleEditBoxKey (int wid, WChar key, uint16 keycode)
| Process keypress for editbox widget.
virtual void | InsertTextString (int wid, const char *str, bool marked, const char *caret, const char *insert_location, const char *replacement_end)
| Insert a text string at the cursor position into the edit box widget.
void | HandleButtonClick (byte widget)
| Do all things to make a button look clicked and mark it to be unclicked in a few ticks.
int | GetRowFromWidget (int clickpos, int widget, int padding, int line_height=-1) const
| Compute the row of a widget that a user clicked in.
void | RaiseButtons (bool autoraise=false)
| Raise the buttons of the window.
void CDECL | SetWidgetsDisabledState (bool disab_stat, int widgets,...)
| Sets the enabled/disabled status of a list of widgets.
void CDECL | SetWidgetsLoweredState (bool lowered_stat, int widgets,...)
| Sets the lowered/raised status of a list of widgets.
void | SetWidgetDirty (byte widget_index) const
| Invalidate a widget, i.e.
void | DrawWidgets () const
| Paint all widgets of a window.
void | DrawViewport () const
| Draw the viewport of this window.
void | DrawSortButtonState (int widget, SortButtonState state) const
| Draw a sort button's up or down arrow symbol.
void | DeleteChildWindows (WindowClass wc=WC_INVALID) const
| Delete all children a window might have in a head-recursive manner.
void | SetDirty () const
| Mark entire window as dirty (in need of re-paint)
void | ReInit (int rx=0, int ry=0)
| Re-initialize a window, and optionally change its size.
bool | IsShaded () const
| Is window shaded currently?
void | SetShaded (bool make_shaded)
| Set the shaded state of the window to make_shaded.
void | InvalidateData (int data=0, bool gui_scope=true)
| Mark this window's data as invalid (in need of re-computing)
void | ProcessScheduledInvalidations ()
| Process all scheduled invalidations.
void | ProcessHighlightedInvalidations ()
| Process all invalidation of highlighted widgets.
virtual void | OnInit ()
| Notification that the nested widget tree gets initialized.
virtual void | ApplyDefaults ()
| Read default values from WindowDesc configuration an apply them to the window.
virtual Point | OnInitialPosition (int16 sm_width, int16 sm_height, int window_number)
| Compute the initial position of the window.
virtual void | OnFocus ()
| Called when window gains focus.
virtual void | OnFocusLost ()
| Called when window looses focus.
virtual EventState | OnKeyPress (WChar key, uint16 keycode)
| A key has been pressed.
virtual EventState | OnCTRLStateChange ()
| The state of the control key has changed.
virtual bool | OnRightClick (Point pt, int widget)
| A click with the right mouse button has been made on the window.
virtual void | OnHover (Point pt, int widget)
| The mouse is hovering over a widget in the window, perform an action for it, like opening a custom tooltip.
virtual void | OnScroll (Point delta)
| Handle the request for (viewport) scrolling.
virtual void | OnMouseOver (Point pt, int widget)
| The mouse is currently moving over the window or has just moved outside of the window.
virtual void | OnMouseWheel (int wheel)
| The mouse wheel has been turned.
virtual void | OnMouseLoop ()
| Called for every mouse loop run, which is at least once per (game) tick.
virtual void | OnTick ()
| Called once per (game) tick.
virtual void | OnHundredthTick ()
| Called once every 100 (game) ticks.
virtual void | OnTimeout ()
| Called when this window's timeout has been reached.
virtual void | OnDropdownClose (Point pt, int widget, int index, bool instant_close)
| A dropdown window associated to this window has been closed.
virtual void | OnEditboxChanged (int widget)
| The text in an editbox has been edited.
virtual bool | OnVehicleSelect (const struct Vehicle *v)
| The user clicked on a vehicle while HT_VEHICLE has been set.
virtual void | OnPlaceDrag (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt)
| The user is dragging over the map when the tile highlight mode has been set.
virtual void | OnPlaceMouseUp (ViewportPlaceMethod select_method, ViewportDragDropSelectionProcess select_proc, Point pt, TileIndex start_tile, TileIndex end_tile)
| The user has dragged over the map when the tile highlight mode has been set.
virtual void | OnPlacePresize (Point pt, TileIndex tile)
| The user moves over the map when a tile highlight mode has been set when the special mouse mode has been set to 'PRESIZE' mode.
virtual bool | IsNewGRFInspectable () const
| Is the data related to this window NewGRF inspectable?
virtual void | ShowNewGRFInspectWindow () const
| Show the NewGRF inspection window.
Public Member Functions inherited from ZeroedMemoryAllocator
void * | operator new (size_t size)
| Memory allocator for a single class instance.
void | operator delete[] (void *ptr)
| Memory release for an array of class instances.

## Static Public Attributes
static HotkeyList | hotkeys

## Private Types
enum | OrderPlaceObjectState { OPOS_NONE, OPOS_GOTO, OPOS_CONDITIONAL, OPOS_SHARE, OPOS_END }
| Under what reason are we using the PlaceObject functionality?
enum | DisplayPane { DP_GROUNDVEHICLE_ROW_NORMAL = 0, DP_GROUNDVEHICLE_ROW_CONDITIONAL = 1, DP_LEFT_LOAD = 0, DP_LEFT_REFIT = 1, DP_MIDDLE_UNLOAD = 0, DP_MIDDLE_SERVICE = 1, DP_RIGHT_EMPTY = 0, DP_RIGHT_REFIT = 1, DP_ROW_LOAD = 0, DP_ROW_DEPOT = 1, DP_ROW_CONDITIONAL = 2, DP_BOTTOM_MIDDLE_DELETE = 0, DP_BOTTOM_MIDDLE_STOP_SHARING = 1 }
| Displayed planes of the NWID_SELECTION widgets. More...

## Private Member Functions
VehicleOrderID | OrderGetSel () const
| Return the memorised selected order.
VehicleOrderID | GetOrderFromPt (int y)
| Calculate the selected order.
void | OrderClick_Goto (OrderPlaceObjectState type)
| Handle the click on the goto button.
void | OrderClick_FullLoad (int load_type)
| Handle the click on the full load button.
void | OrderHotkey_NoLoad ()
| Handle the 'no loading' hotkey.
void | OrderClick_Service (int i)
| Handle the click on the service.
void | OrderClick_NearestDepot ()
| Handle the click on the service in nearest depot button.
void | OrderClick_Unload (int unload_type)
| Handle the click on the unload button.
void | OrderHotkey_Transfer ()
| Handle the transfer hotkey.
void | OrderHotkey_NoUnload ()
| Handle the 'no unload' hotkey.
void | OrderClick_Nonstop (int non_stop)
| Handle the click on the nonstop button.
void | OrderClick_Skip ()
| Handle the click on the skip button.
void | OrderClick_Delete ()
| Handle the click on the delete button.
void | OrderClick_StopSharing ()
| Handle the click on the 'stop sharing' button.
void | OrderClick_Refit (int i, bool auto_refit)
| Handle the click on the refit button.
void | UpdateAutoRefitState ()
| Cache auto-refittability of the vehicle chain.

## Private Attributes
int | selected_order
VehicleOrderID | order_over
| Order over which another order is dragged, `INVALID_VEH_ORDER_ID` if none.
OrderPlaceObjectState | goto_type
const Vehicle * | vehicle
| Vehicle owning the orders being displayed and manipulated.
Scrollbar * | vscroll
bool | can_do_refit
| Vehicle chain can be refitted in depot.
bool | can_do_autorefit
| Vehicle chain can be auto-refitted.

## Additional Inherited Members
Static Public Member Functions inherited from Window
static int | SortButtonWidth ()
| Get width of up/down arrow of sort button state.
Data Fields inherited from Window
WindowDesc * | window_desc
| Window description.
WindowFlags | flags
| Window flags.
WindowClass | window_class
| Window class.
WindowNumber | window_number
| Window number within the window class.
uint8 | timeout_timer
| Timer value of the WF_TIMEOUT for flags.
uint8 | white_border_timer
| Timer value of the WF_WHITE_BORDER for flags.
int | left
| x position of left edge of the window
int | top
| y position of top edge of the window
int | width
| width of the window (number of pixels to the right in x direction)
int | height
| Height of the window (number of pixels down in y direction)
ResizeInfo | resize
| Resize information.
Owner | owner
| The owner of the content shown in this window. Company colour is acquired from this variable.
ViewportData * | viewport
| Pointer to viewport data, if present.
const NWidgetCore * | nested_focus
| Currently focused nested widget, or `NULL` if no nested widget has focus.
SmallMap< int, QueryString * > | querystrings
| QueryString associated to WWT_EDITBOX widgets.
NWidgetBase * | nested_root
| Root of the nested tree.
NWidgetBase ** | nested_array
| Array of pointers into the tree. Do not access directly, use Window::GetWidget() instead.
uint | nested_array_size
| Size of the nested array.
NWidgetStacked * | shade_select
| Selection widget (NWID_SELECTION) to use for shading the window. If `NULL`, window cannot shade.
Dimension | unshaded_size
| Last known unshaded size (only valid while shaded).
int | scrolling_scrollbar
| Widgetindex of just being dragged scrollbar. -1 if none is active.
Window * | parent
| Parent window.
Window * | z_front
| The window in front of us in z-order.
Window * | z_back
| The window behind us in z-order.
Protected Member Functions inherited from Window
void | InitializeData (WindowNumber window_number)
| Initializes the data (except the position and initial size) of a new Window.
void | InitializePositionSize (int x, int y, int min_width, int min_height)
| Set the position and smallest size of the window.
virtual void | FindWindowPlacementAndResize (int def_width, int def_height)
| Resize window towards the default size.
Protected Attributes inherited from Window
SmallVector< int, 4 > | scheduled_invalidation_data
| Data of scheduled OnInvalidateData() calls.

## Detailed Description

Order window code for all vehicles.

At the bottom of the window two button rows are located for changing the orders of the vehicle.

# Top row

The top-row is for manipulating an individual order. What row is displayed depends on the type of vehicle, and whether or not you are the owner of the vehicle.

The top-row buttons of one of your trains or road vehicles is one of the following three cases:

    * +-----------------+-----------------+-----------------+-----------------+
    * |    NON-STOP     |    FULL_LOAD    |     UNLOAD      |      REFIT      | (normal)
    * +-----------------+-----+-----------+-----------+-----+-----------------+
    * |       COND_VAR        |    COND_COMPARATOR    |      COND_VALUE       | (for conditional orders)
    * +-----------------+-----+-----------+-----------+-----+-----------------+
    * |    NON-STOP     |      REFIT      |     SERVICE     |     (empty)     | (for depot orders)
    * +-----------------+-----------------+-----------------+-----------------+
    *

Airplanes and ships have one of the following three top-row button rows:

    * +-----------------+-----------------+-----------------+
    * |    FULL_LOAD    |     UNLOAD      |      REFIT      | (normal)
    * +-----------------+-----------------+-----------------+
    * |    COND_VAR     | COND_COMPARATOR |   COND_VALUE    | (for conditional orders)
    * +-----------------+--------+--------+-----------------+
    * |            REFIT         |          SERVICE         | (for depot order)
    * +--------------------------+--------------------------+
    *

# Bottom row

The second row (the bottom row) is for manipulating the list of orders:

    * +-----------------+-----------------+-----------------+
    * |      SKIP       |     DELETE      |      GOTO       |
    * +-----------------+-----------------+-----------------+
    *

For vehicles of other companies, both button rows are not displayed.

Definition at line 472 of file order_gui.cpp.

## Member Enumeration Documentation

enum OrdersWindow::DisplayPane
| private

Displayed planes of the NWID_SELECTION widgets.

Enumerator:

  DP_GROUNDVEHICLE_ROW_NORMAL | Display the row for normal/depot orders in the top row of the train/rv order window.
  DP_GROUNDVEHICLE_ROW_CONDITIONAL | Display the row for conditional orders in the top row of the train/rv order window.
  DP_LEFT_LOAD | Display 'load' in the left button of the top row of the train/rv order window.
  DP_LEFT_REFIT | Display 'refit' in the left button of the top row of the train/rv order window.
  DP_MIDDLE_UNLOAD | Display 'unload' in the middle button of the top row of the train/rv order window.
  DP_MIDDLE_SERVICE | Display 'service' in the middle button of the top row of the train/rv order window.
  DP_RIGHT_EMPTY | Display an empty panel in the right button of the top row of the train/rv order window.
  DP_RIGHT_REFIT | Display 'refit' in the right button of the top row of the train/rv order window.
  DP_ROW_LOAD | Display 'load' / 'unload' / 'refit' buttons in the top row of the ship/airplane order window.
  DP_ROW_DEPOT | Display 'refit' / 'service' buttons in the top row of the ship/airplane order window.
  DP_ROW_CONDITIONAL | Display the conditional order buttons in the top row of the ship/airplane order window.
  DP_BOTTOM_MIDDLE_DELETE | Display 'delete' in the middle button of the bottom row of the vehicle order window.
  DP_BOTTOM_MIDDLE_STOP_SHARING | Display 'stop sharing' in the middle button of the bottom row of the vehicle order window.

Definition at line 484 of file order_gui.cpp.

## Member Function Documentation

virtual void OrdersWindow::DrawWidget | ( | const Rect & | r,
|  | int | widget
| ) |  | const
| inlinevirtual

Draw the contents of a nested widget.

Parameters

  r | Rectangle occupied by the widget.
  widget | Number of the widget to draw.

Note
  This method may not change any state, it may only use drawing functions.

Reimplemented from Window.

Definition at line 1080 of file order_gui.cpp.

References _colour_gradient, _current_text_dir, DrawOrderString(), DrawString(), Vehicle::GetNumOrders(), Vehicle::GetOrder(), Scrollbar::GetPosition(), GetSpriteSize(), GetStringBoundingBox(), GfxFillRect(), INVALID_VEH_ORDER_ID, Vehicle::IsOrderListShared(), Scrollbar::IsVisible(), max(), min(), Order::next, order_over, SetDParamMaxValue(), TD_RTL, Window::top, vehicle, WD_FRAMERECT_BOTTOM, WD_FRAMERECT_TOP, WD_FRAMETEXT_LEFT, WD_FRAMETEXT_RIGHT, and WID_O_ORDER_LIST.

VehicleOrderID OrdersWindow::GetOrderFromPt | ( | int | y | ) |
| inlineprivate

Calculate the selected order.

The calculation is based on the relative (to the window) y click position and the position of the scrollbar.

Parameters

  y | Y-value of the click relative to the window origin

Returns
  The selected order if the order is valid, else return `INVALID_VEH_ORDER_ID`.

Definition at line 538 of file order_gui.cpp.

References Scrollbar::GetCapacity(), Scrollbar::GetPosition(), INVALID_VEH_ORDER_ID, NWidgetBase::pos_y, NWidgetBase::resize_y, WD_FRAMERECT_TOP, and WID_O_ORDER_LIST.

Referenced by OnClick(), OnDragDrop(), and OnMouseDrag().

virtual void OrdersWindow::OnClick | ( | Point | pt,
|  | int | widget,
|  | int | click_count
| ) |  |
| inlinevirtual

A click with the left mouse button has been made on the window.

Parameters

  pt | the point inside the window that has been clicked.
  widget | the clicked widget.
  click_count | Number of fast consecutive clicks at same position

Reimplemented from Window.

Definition at line 1159 of file order_gui.cpp.

References _ctrl_pressed, _local_company, _order_conditional_variable, SmallVector< T, S >::Append(), CMD_INSERT_ORDER, CMD_MODIFY_ORDER, CMD_MSG, ConvertSpeedToDisplaySpeed(), CS_NUMERAL, Window::DeleteChildWindows(), DoCommandP(), Order::GetConditionComparator(), Order::GetConditionValue(), Order::GetConditionVariable(), Order::GetLocation(), Order::GetNonStopType(), Vehicle::GetNumOrders(), Vehicle::GetOrder(), GetOrderFromPt(), HideDropDownMenu(), HT_DRAG, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, INVALID_TILE, INVALID_VEH_ORDER_ID, Order::IsType(), lengthof, Order::MakeConditional(), MOF_STOP_LOCATION, Order::next, OCV_MAX_SPEED, OCV_REQUIRES_SERVICE, OrderClick_Delete(), OrderClick_FullLoad(), OrderClick_Goto(), OrderClick_Nonstop(), OrderClick_Refit(), OrderClick_Service(), OrderClick_Skip(), OrderClick_StopSharing(), OrderClick_Unload(), OrderGetSel(), Vehicle::owner, Order::Pack(), CursorVars::pos, ResetObjectToPlace(), ScrollMainWindowToTile(), SetDParam(), SetObjectToPlaceWnd(), ShowDropDownList(), ShowDropDownMenu(), ShowQueryString(), ShowTimetableWindow(), SPR_CURSOR_MOUSE, Vehicle::tile, BaseVehicle::type, VEH_AIRCRAFT, VEH_TRAIN, vehicle, WID_O_COND_COMPARATOR, WID_O_COND_VALUE, WID_O_COND_VARIABLE, WID_O_DELETE, WID_O_FULL_LOAD, WID_O_GOTO, WID_O_NON_STOP, WID_O_ORDER_LIST, WID_O_REFIT, WID_O_REFIT_DROPDOWN, WID_O_SERVICE, WID_O_SHARED_ORDER_LIST, WID_O_SKIP, WID_O_STOP_SHARING, WID_O_TIMETABLE_VIEW, and WID_O_UNLOAD.

virtual void OrdersWindow::OnDragDrop | ( | Point | pt,
|  | int | widget
| ) |  |
| inlinevirtual

A dragged 'object' has been released.

Parameters

  pt | the point inside the window where the release took place.
  widget | the widget where the release took place.

Reimplemented from Window.

Definition at line 1390 of file order_gui.cpp.

References CMD_MOVE_ORDER, CMD_MSG, DoCommandP(), Vehicle::GetNumOrders(), GetOrderFromPt(), INVALID_VEH_ORDER_ID, order_over, OrderClick_Delete(), OrderClick_StopSharing(), OrderGetSel(), ResetObjectToPlace(), Window::SetWidgetDirty(), Vehicle::tile, vehicle, WID_O_DELETE, WID_O_ORDER_LIST, and WID_O_STOP_SHARING.

virtual void OrdersWindow::OnDropdownSelect | ( | int | widget,
|  | int | index
| ) |  |
| inlinevirtual

A dropdown option associated to this window has been selected.

Parameters

  widget | the widget (button) that the dropdown is associated with.
  index | the element in the dropdown that is selected.

Reimplemented from Window.

Definition at line 1347 of file order_gui.cpp.

References CMD_MODIFY_ORDER, CMD_MSG, DoCommandP(), MOF_COND_COMPARATOR, MOF_COND_VARIABLE, OrderClick_FullLoad(), OrderClick_Goto(), OrderClick_NearestDepot(), OrderClick_Nonstop(), OrderClick_Refit(), OrderClick_Service(), OrderClick_Unload(), Vehicle::tile, vehicle, WID_O_COND_COMPARATOR, WID_O_COND_VARIABLE, WID_O_FULL_LOAD, WID_O_GOTO, WID_O_NON_STOP, WID_O_REFIT_DROPDOWN, WID_O_SERVICE, and WID_O_UNLOAD.

virtual EventState OrdersWindow::OnHotkey | ( | int | hotkey | ) |
| inlinevirtual

A hotkey has been pressed.

Parameters

  hotkey | Hotkey index, by default a widget index of a button or editbox.

Returns
  ES_HANDLED if the key press has been handled, and the hotkey is not unavailable for some reason.

Reimplemented from Window.

Definition at line 1423 of file order_gui.cpp.

References _local_company, ES_HANDLED, ES_NOT_HANDLED, OrderClick_Delete(), OrderClick_FullLoad(), OrderClick_Goto(), OrderClick_NearestDepot(), OrderClick_Nonstop(), OrderClick_Service(), OrderClick_Skip(), OrderClick_Unload(), OrderHotkey_NoLoad(), OrderHotkey_NoUnload(), OrderHotkey_Transfer(), Vehicle::owner, and vehicle.

virtual void OrdersWindow::OnInvalidateData | ( | int | data = `0`,
|  | bool | gui_scope = `true`
| ) |  |
| inlinevirtual

Some data on this window has become invalid.

Parameters

  data | Information about the changed data.
  gui_scope | Whether the call is done from GUI scope. You may not do everything when not in GUI scope. See InvalidateWindowData() for details.

Reimplemented from Window.

Definition at line 835 of file order_gui.cpp.

References Window::DeleteChildWindows(), GB(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_vehicle_pool >::Get(), Vehicle::GetNumOrders(), HideDropDownMenu(), INVALID_VEH_ORDER_ID, Scrollbar::IsVisible(), Scrollbar::ScrollTowards(), Scrollbar::SetCount(), UpdateAutoRefitState(), vehicle, VIWD_AUTOREPLACE, VIWD_CONSIST_CHANGED, VIWD_MODIFY_ORDERS, VIWD_REMOVE_ALL_ORDERS, and Window::window_number.

virtual void OrdersWindow::OnMouseDrag | ( | Point | pt,
|  | int | widget
| ) |  |
| inlinevirtual

An 'object' is being dragged at the provided position, highlight the target if possible.

Parameters

  pt | The point inside the window that the mouse hovers over.
  widget | The widget the mouse hovers over.

Reimplemented from Window.

Definition at line 1487 of file order_gui.cpp.

References Vehicle::GetNumOrders(), GetOrderFromPt(), INVALID_VEH_ORDER_ID, order_over, OrderGetSel(), Window::SetWidgetDirty(), vehicle, and WID_O_ORDER_LIST.

virtual void OrdersWindow::OnPaint | ( |  | ) |
| inlinevirtual

The window must be repainted.

Note
  This method should not change any state, it should only use drawing functions.

Reimplemented from Window.

Definition at line 1070 of file order_gui.cpp.

References _local_company, Window::DrawWidgets(), Vehicle::owner, Window::SetWidgetLoweredState(), vehicle, and WID_O_GOTO.

virtual void OrdersWindow::OnPlaceObject | ( | Point | pt,
|  | TileIndex | tile
| ) |  |
| inlinevirtual

The user clicked some place on the map when a tile highlight mode has been set.

Parameters

  pt | the exact point on the map that has been clicked.
  tile | the tile on the map that has been clicked.

Reimplemented from Window.

Definition at line 1444 of file order_gui.cpp.

References _settings_client, CMD_INSERT_ORDER, CMD_MSG, DoCommandP(), GetOrderCmdFromTile(), ClientSettings::gui, Order::IsType(), Order::Pack(), GUISettings::quick_goto, ResetObjectToPlace(), Vehicle::tile, and vehicle.

virtual void OrdersWindow::OnQueryTextFinished | ( | char * | str | ) |
| inlinevirtual

The query window opened from this window has closed.

Parameters

  str | the new value of the string, NULL if the window was cancelled or an empty string when the default button was pressed, i.e. StrEmpty(str).

Reimplemented from Window.

Definition at line 1324 of file order_gui.cpp.

References Clamp(), CMD_MODIFY_ORDER, CMD_MSG, ConvertDisplaySpeedToSpeed(), DoCommandP(), Order::GetConditionVariable(), Vehicle::GetOrder(), MOF_COND_VALUE, OCV_LOAD_PERCENTAGE, OCV_MAX_SPEED, OCV_RELIABILITY, OrderGetSel(), StrEmpty(), Vehicle::tile, and vehicle.

virtual void OrdersWindow::OnResize | ( |  | ) |
| inlinevirtual

Called after the window got resized.

For nested windows with a viewport, call NWidgetViewport::UpdateViewportCoordinates.

Reimplemented from Window.

Definition at line 1507 of file order_gui.cpp.

References Scrollbar::SetCapacityFromWidget(), and WID_O_ORDER_LIST.

void OrdersWindow::OrderClick_FullLoad | ( | int | load_type | ) |
| inlineprivate

Handle the click on the full load button.

Parameters

  load_type | the way to load.

Definition at line 571 of file order_gui.cpp.

References CMD_MODIFY_ORDER, CMD_MSG, DoCommandP(), Order::GetLoadType(), Vehicle::GetOrder(), MOF_LOAD, OLF_FULL_LOAD_ANY, OLF_LOAD_IF_POSSIBLE, OrderGetSel(), Vehicle::tile, and vehicle.

Referenced by OnClick(), OnDropdownSelect(), OnHotkey(), and OrderHotkey_NoLoad().

void OrdersWindow::OrderClick_Nonstop | ( | int | non_stop | ) |
| inlineprivate

Handle the click on the nonstop button.

Parameters

  non_stop | what non-stop type to use; -1 to use the 'next' one.

Definition at line 665 of file order_gui.cpp.

References CMD_MODIFY_ORDER, CMD_MSG, DoCommandP(), Order::GetNonStopType(), Vehicle::GetOrder(), Vehicle::IsGroundVehicle(), MOF_NON_STOP, ONSF_NO_STOP_AT_INTERMEDIATE_STATIONS, OrderGetSel(), Window::SetWidgetDirty(), Vehicle::tile, vehicle, and WID_O_NON_STOP.

Referenced by OnClick(), OnDropdownSelect(), and OnHotkey().

void OrdersWindow::OrderClick_Refit | ( | int | i,
|  | bool | auto_refit
| ) |  |
| inlineprivate

Handle the click on the refit button.

If ctrl is pressed, cancel refitting, else show the refit window.

Parameters

  i | Selected refit command.
  auto_refit | Select refit for auto-refitting.

Definition at line 741 of file order_gui.cpp.

References _ctrl_pressed, CMD_ORDER_REFIT, CT_AUTO_REFIT, CT_NO_REFIT, DoCommandP(), OrderGetSel(), ShowVehicleRefitWindow(), Vehicle::tile, and vehicle.

Referenced by OnClick(), and OnDropdownSelect().

void OrdersWindow::OrderClick_Skip | ( |  | ) |
| inlineprivate

Handle the click on the skip button.

If ctrl is pressed, skip to selected order, else skip to current order + 1

Definition at line 687 of file order_gui.cpp.

References _ctrl_pressed, CMD_MSG, CMD_SKIP_TO_ORDER, BaseConsist::cur_implicit_order_index, DoCommandP(), Vehicle::GetNumOrders(), Vehicle::tile, and vehicle.

Referenced by OnClick(), and OnHotkey().

void OrdersWindow::OrderClick_StopSharing | ( |  | ) |
| inlineprivate

Handle the click on the 'stop sharing' button.

If 'End of Shared Orders' isn't selected, do nothing. If Ctrl is pressed, call OrderClick_Delete and exit. To stop sharing this vehicle order list, we copy the orders of a vehicle that share this order list. That way we exit the group of shared vehicles while keeping the same order list.

Definition at line 717 of file order_gui.cpp.

References _ctrl_pressed, CMD_CLONE_ORDER, CMD_MSG, DoCommandP(), Vehicle::FirstShared(), Vehicle::GetNumOrders(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, Vehicle::IsOrderListShared(), Vehicle::NextShared(), OrderClick_Delete(), Vehicle::PreviousShared(), Vehicle::tile, and vehicle.

Referenced by OnClick(), and OnDragDrop().

VehicleOrderID OrdersWindow::OrderGetSel | ( |  | ) | const
| inlineprivate

Return the memorised selected order.

Returns
  the memorised order if it is a valid one else return the number of orders

Definition at line 524 of file order_gui.cpp.

References Vehicle::GetNumOrders(), and vehicle.

Referenced by OnClick(), OnDragDrop(), OnMouseDrag(), OnQueryTextFinished(), OrderClick_FullLoad(), OrderClick_Nonstop(), OrderClick_Refit(), OrderClick_Service(), OrderClick_Unload(), and SetStringParameters().

virtual void OrdersWindow::SetStringParameters | ( | int | widget | ) | const
| inlinevirtual

Initialize string parameters for a widget.

Calls to this function are made during initialization to measure the size (that is as part of InitNested()), during drawing, and while re-initializing the window. Only for widgets that render text initializing is requested.

Parameters

  widget | Widget number.

Reimplemented from Window.

Definition at line 1138 of file order_gui.cpp.

References ConvertSpeedToDisplaySpeed(), Order::GetConditionValue(), Order::GetConditionVariable(), Vehicle::GetOrder(), Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem< Tpool >::index, Order::IsType(), OCV_MAX_SPEED, OrderGetSel(), SetDParam(), vehicle, WID_O_CAPTION, and WID_O_COND_VALUE.

void OrdersWindow::UpdateAutoRefitState | ( |  | ) |
| inlineprivate

Cache auto-refittability of the vehicle chain.

Definition at line 756 of file order_gui.cpp.

References can_do_autorefit, can_do_refit, EF_AUTO_REFIT, Pool< Titem, Tindex, Tgrowth_step, Tmax_size, Tpool_type, Tcache, Tzero >::PoolItem<&_engine_pool >::Get(), HasBit(), IsEngineRefittable(), Vehicle::IsGroundVehicle(), and vehicle.

Referenced by OnInvalidateData().

virtual void OrdersWindow::UpdateWidgetSize | ( | int | widget,
|  | Dimension * | size,
|  | const Dimension & | padding,
|  | Dimension * | fill,
|  | Dimension * | resize
| ) |  |
| inlinevirtual

Update size and resize step of a widget in the window.

After retrieval of the minimal size and the resize-steps of a widget, this function is called to allow further refinement, typically by computing the real maximal size of the content. Afterwards, size is taken to be the minimal size of the widget and resize is taken to contain the resize steps. For the convenience of the callee, padding contains the amount of padding between the content and the edge of the widget. This should be added to the returned size.

Parameters

  widget | Widget number.
  size | Size of the widget.
  padding | Recommended amount of space between the widget content and the widget edge.
  fill | Fill step of the widget.
  resize | Resize step of the widget.

Reimplemented from Window.

Definition at line 798 of file order_gui.cpp.

References _order_conditional_variable, FONT_HEIGHT_NORMAL, GetStringBoundingBox(), INVALID_STRING_ID, lengthof, maxdim(), WD_FRAMERECT_BOTTOM, WD_FRAMERECT_TOP, WID_O_COND_COMPARATOR, WID_O_COND_VARIABLE, and WID_O_ORDER_LIST.

The documentation for this struct was generated from the following file:

- src/order_gui.cpp